package com.zhrj.scan.web.service;

package ..deTemp.1733453075832;

import com.zhrj.scan.web.dao.MainDao;
import com.zhrj.scan.web.misc.DataConvert;
import com.zhrj.scan.web.misc.PageUtil;
import com.zhrj.scan.web.misc.Paginate;
import com.zhrj.scan.web.model.AccessToken;
import com.zhrj.scan.web.model.CommCollection;
import com.zhrj.scan.web.model.CommUser;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpSession;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class MainService {
  @Autowired
  private MainDao mainDao;
  
  @Transactional
  public Map<String, Object> addCardInfo(String name, String bank, String card, String idcard, String socialnum, String state, HttpSession httpSession) {
    Map<String, Object> map = new HashMap<>();
    CommUser commUser = (CommUser)httpSession.getAttribute("__login_user");
    if (name == null || name.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，姓名为空！");
    } else if (bank == null || bank.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，银行信息为空！");
    } else if (card == null || card.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，银行卡号为空！");
    } else if (idcard == null || idcard.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，社会保障号码为空！");
    } else if (socialnum == null || socialnum.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，卡号为空！");
    } else if (state == null || state.equals("")) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "提交失败，状态为空！");
    } else {
      int num = this.mainDao.getCardCntByIdCard(idcard);
      if (num > 0) {
        map.put("code", "2");
        map.put("msg", "该卡信息已存在！");
        return map;
      } 
      String userid = "131";
      int cardMaxNum = this.mainDao.getCardMaxNum(userid);
      CommCollection commCollection = new CommCollection();
      commCollection.setIdcard(idcard);
      commCollection.setBank(bank);
      commCollection.setCard(card);
      commCollection.setName(name);
      commCollection.setSocialnum(socialnum);
      String data = DataConvert.getTime("time");
      commCollection.setTime(data);
      commCollection.setUserid(Integer.parseInt(userid));
      commCollection.setState(state);
      commCollection.setNumber(cardMaxNum + 1);
      int res = 0;
      try {
        res = this.mainDao.addCardInfo(commCollection);
      } catch (Exception exception) {
        throw new RuntimeException("提交信息异常，请重新提交！");
      } 
      if (res > 0) {
        map.put("code", "0");
        map.put("msg", "添加信息成功!");
      } else {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "添加信息失败!");
      } 
    } 
    return map;
  }
  
  public Object getCardLst(String pageIndex, String condition, HttpSession httpSession) {
    Map<String, Object> map = new HashMap<>();
    Map<String, Object> param = new HashMap<>();
    CommUser commUser = (CommUser)httpSession.getAttribute("__login_user");
    String userid = "131";
    Paginate p = new Paginate();
    if (pageIndex != null)
      p.setPageIndex(Integer.parseInt(pageIndex)); 
    param.put("condition", condition);
    param.put("startRow", Integer.valueOf(p.getStartRow()));
    param.put("pageSize", Integer.valueOf(p.getPageSize()));
    param.put("userid", userid);
    List<CommCollection> commCollectionList = this.mainDao.getCardLst(param);
    int num = this.mainDao.getCommNum(param);
    int pt = PageUtil.getTotalPages(Integer.valueOf(p.getPageSize()), Integer.valueOf(num)).intValue();
    int pi = p.getPageIndex();
    Map<String, Object> timeMap = new HashMap<>();
    timeMap.put("userid", userid);
    int totalCnt = this.mainDao.getCommNum(timeMap);
    timeMap.put("time", DataConvert.getTime("date"));
    int todayCnt = this.mainDao.getCommNum(timeMap);
    int noBoxCnt = this.mainDao.getNoBoxCardCnt(userid);
    int noCrateCnt = this.mainDao.getNoCrateBoxCnt(userid);
    int totalPage = PageUtil.getTotalPages(Integer.valueOf(8), Integer.valueOf(todayCnt)).intValue();
    map.put("commCollectionList", commCollectionList);
    map.put("pageTotal", Integer.valueOf(pt));
    map.put("pageIndex", Integer.valueOf(pi));
    map.put("totalNum", Integer.valueOf(totalCnt));
    map.put("todayNum", Integer.valueOf(todayCnt));
    map.put("noBoxNum", Integer.valueOf(noBoxCnt));
    map.put("noCrateNum", Integer.valueOf(noCrateCnt));
    map.put("totalPage", Integer.valueOf(totalPage));
    return map;
  }
  
  @Transactional
  public Map<String, Object> boxing(String begin, String end, HttpSession httpSession) {
    Map<String, Object> map = new HashMap<>();
    Map<String, Object> paramMap = new HashMap<>();
    CommUser commUser = (CommUser)httpSession.getAttribute("__login_user");
    String userid = "131";
    int noBoxCnt = this.mainDao.getNoBoxCardCnt(userid);
    if (noBoxCnt == 0) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "可装盒的卡数量为0！");
      return map;
    } 
    int maxBoxNum = this.mainDao.getMaxBoxNum(userid);
    int currentBoxNum = maxBoxNum + 1;
    paramMap.put("userid", userid);
    paramMap.put("box", Integer.valueOf(currentBoxNum));
    paramMap.put("btime", DataConvert.getTime("time"));
    if (!begin.trim().equals("") && !end.trim().equals("")) {
      int beginNum = Integer.parseInt(begin);
      int endNum = Integer.parseInt(end);
      if (beginNum > endNum) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "起始序号大于结束序号，请重新输入！");
        return map;
      } 
      paramMap.put("number", Integer.valueOf(beginNum));
      int cardCnt = this.mainDao.getCardCnt(paramMap);
      if (cardCnt == 0) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "起始顺序号不存在或已装盒，请正确输入起始序号！");
        return map;
      } 
      paramMap.put("number", Integer.valueOf(endNum));
      cardCnt = this.mainDao.getCardCnt(paramMap);
      if (cardCnt == 0) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "截止顺序号不存在或已装盒，请正确输入截止序号！");
        return map;
      } 
      if (endNum - beginNum > 249) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "装盒卡片数不能大于250张，请重新选择！");
        return map;
      } 
      int res = 0;
      for (int i = beginNum, j = 1; i < endNum + 1; i++, j++) {
        paramMap.put("serical", Integer.valueOf(j));
        paramMap.put("number", Integer.valueOf(i));
        try {
          res = this.mainDao.boxing(paramMap);
        } catch (Exception exception) {
          throw new RuntimeException();
        } 
      } 
      int cardNum = this.mainDao.getBoxCnt(paramMap);
      if (res > 0) {
        map.put("code", Integer.valueOf(0));
        map.put("msg", "装盒成功！本次共计装盒 " + cardNum + "张卡片，盒编号为" + currentBoxNum);
      } 
    } else {
      int res = 0;
      for (int i = 1; i < noBoxCnt + 1; i++) {
        int minCardId = this.mainDao.getMinCardId(userid);
        paramMap.put("id", Integer.valueOf(minCardId));
        paramMap.put("serical", Integer.valueOf(i));
        try {
          res = this.mainDao.boxingAll(paramMap);
        } catch (Exception exception) {
          throw new RuntimeException();
        } 
      } 
      if (res > 0) {
        map.put("code", Integer.valueOf(0));
        map.put("msg", "装盒成功！本次共计装盒 " + noBoxCnt + "张卡片，盒编号为" + currentBoxNum);
      } 
    } 
    return map;
  }
  
  @Transactional
  public Map<String, Object> packing(String begin, String end, HttpSession httpSession) {
    Map<String, Object> map = new HashMap<>();
    Map<String, Object> paramMap = new HashMap<>();
    CommUser commUser = (CommUser)httpSession.getAttribute("__login_user");
    String userid = "131";
    int noCrateCnt = this.mainDao.getNoCrateBoxCnt(userid);
    if (noCrateCnt == 0) {
      map.put("code", Integer.valueOf(1));
      map.put("msg", "可装箱的盒数量为0！");
      return map;
    } 
    paramMap.put("userid", userid);
    String data = DataConvert.getTime("number").substring(2);
    paramMap.put("prctime", data);
    int maxCrateNum = this.mainDao.getMaxCrateNum(paramMap);
    int currentCrateNum = maxCrateNum + 1;
    paramMap.put("crate", Integer.valueOf(currentCrateNum));
    paramMap.put("ctime", DataConvert.getTime("time"));
    if (!begin.trim().equals("") && !end.trim().equals("")) {
      int beginNum = Integer.parseInt(begin);
      int endNum = Integer.parseInt(end);
      if (beginNum > endNum) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "起始盒号大于结束盒号，请重新输入！");
        return map;
      } 
      paramMap.put("box", Integer.valueOf(beginNum));
      int boxCnt = this.mainDao.getBoxCnt(paramMap);
      if (boxCnt == 0) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "起始顺序号不存在，请正确输入起始序号！");
        return map;
      } 
      paramMap.put("box", Integer.valueOf(endNum));
      boxCnt = this.mainDao.getBoxCnt(paramMap);
      if (boxCnt == 0) {
        map.put("code", Integer.valueOf(1));
        map.put("msg", "截止顺序号不存在，请正确输入截止序号！");
        return map;
      } 
      int res = 0;
      for (int i = beginNum; i < endNum + 1; i++) {
        paramMap.put("box", Integer.valueOf(i));
        try {
          res = this.mainDao.packing(paramMap);
        } catch (Exception exception) {
          throw new RuntimeException();
        } 
      } 
      int boxNum = endNum - beginNum + 1;
      if (res > 0) {
        map.put("code", Integer.valueOf(0));
        map.put("msg", "装箱成功！本次共计装箱 " + boxNum + "盒， 箱编号为:" + currentCrateNum);
      } 
    } else {
      int res = 0;
      try {
        res = this.mainDao.packingAll(paramMap);
      } catch (Exception exception) {
        throw new RuntimeException();
      } 
      if (res > 0) {
        map.put("code", Integer.valueOf(0));
        map.put("msg", "装箱成功!本次共计装箱 " + noCrateCnt + "盒， 箱编号为:" + currentCrateNum);
      } 
    } 
    return map;
  }
  
  public CommCollection getCardInfo(String id) {
    CommCollection res = this.mainDao.getCardInfo(id);
    res.setCrate(String.valueOf(res.getUserid()) + "-" + res.getPrctime() + "-" + res.getCrate());
    return res;
  }
  
  public int modCardInfo(String id, String name, String bank, String card, String idcard, String socialnum, String state) {
    Map<String, Object> map = new HashMap<>();
    map.put("id", id);
    map.put("name", name);
    map.put("bank", bank);
    map.put("socialnum", socialnum);
    map.put("card", card);
    map.put("idcard", idcard);
    map.put("state", state);
    int res = this.mainDao.modCardInfo(map);
    return res;
  }
  
  public String getToken() {
    AccessToken accessToken = this.mainDao.getaccessToken();
    String token = accessToken.getAccesstoken();
    return token;
  }
}
